<?php

namespace UnicaenDbImport\CodeGenerator\PostgreSQL;

use Doctrine\DBAL\Platforms\AbstractPlatform;
use Doctrine\DBAL\Platforms\PostgreSqlPlatform;
use UnicaenDbImport\CodeGenerator\PostgreSQL\Helper\DiffViewHelper as PostgreSQLDiffViewHelper;
use UnicaenDbImport\CodeGenerator\PostgreSQL\Helper\LogTableHelper as PostgreSQLLogTableHelper;
use UnicaenDbImport\CodeGenerator\PostgreSQL\Helper\TableValidationHelper as PostgreSQLTableValidationHelper;
use UnicaenDbImport\CodeGenerator\PostgreSQL\Helper\TableHelper as PostgreSQLTableHelper;

/**
 * Version PostgreSQL.
 *
 * @author Unicaen
 */
class CodeGenerator extends \UnicaenDbImport\CodeGenerator\CodeGenerator
{
    /**
     * @var PostgreSqlPlatform
     */
    protected $platform;

    /**
     * @var PostgreSQLTableHelper
     */
    protected $tableHelper;

    /**
     * @var PostgreSQLTableValidationHelper
     */
    protected $tableValidationHelper;

    /**
     * @var PostgreSQLDiffViewHelper
     */
    protected $diffViewHelper;

    /**
     * @var PostgreSQLLogTableHelper
     */
    protected $logTableHelper;

    /**
     * CodeGenerator constructor.
     *
     * @param AbstractPlatform $platform
     */
    public function __construct(AbstractPlatform $platform)
    {
        parent::__construct($platform);

        $this->tableHelper = new PostgreSQLTableHelper($this->platform);
        $this->tableValidationHelper = new PostgreSQLTableValidationHelper($this->platform);
        $this->diffViewHelper = new PostgreSQLDiffViewHelper($this->platform);
        $this->logTableHelper = new PostgreSQLLogTableHelper($this->platform);
    }

    /**
     * @param string $tableName
     * @return string
     * @codeCoverageIgnore
     */
    public function generateSQLForIntermmediateTableDrop($tableName)
    {
        return "DROP TABLE IF EXISTS $tableName CASCADE ;";
    }
}