<?php

namespace UnicaenDbImport\Domain;

use DateTime;
use Exception;

interface ResultInterface
{
    /**
     * @return Exception
     */
    public function getException();

    /**
     * @param Exception $exception
     * @return self
     */
    public function setException(Exception $exception = null);

    /**
     * @param DateTime $startDate
     * @return self
     */
    public function setStartDate(DateTime $startDate);

    /**
     * @param DateTime $endDate
     * @return self
     */
    public function setEndDate(DateTime $endDate);

    /**
     * @return DateTime
     */
    public function getStartDate(): DateTime;

    /**
     * @return DateTime
     */
    public function getEndDate(): DateTime;

    /**
     * @param bool $includeDetails
     * @return string
     */
    public function toString($includeDetails = false);
}