<?php

namespace UnicaenDbImport\Domain;

class SynchroResult extends Result
{
    /**
     * @var SynchroInterface
     */
    private $synchro;

    /**
     * @param $rows
     */
    public function setDiffViewRequestResult(array $rows)
    {
        $dataByOperation = [];
        foreach ($rows as $row) {
            $operation = $row['operation'];

            if (!array_key_exists($operation, $dataByOperation)) {
                $dataByOperation[$operation] = [];
            }

            // count
            if (!array_key_exists('count', $dataByOperation[$operation])) {
                $dataByOperation[$operation]['count'] = 0;
            }
            $dataByOperation[$operation]['count'] += 1;
        }
        foreach ($dataByOperation as $operation => $data) {
            $this->setResultsForOperation($data, $operation);
        }
    }

    /**
     * @param SynchroInterface $synchro
     * @return static
     */
    public function setSynchro(SynchroInterface $synchro)
    {
        $this->synchro = $synchro;

        return $this;
    }

    /**
     * @return SynchroInterface
     */
    public function getSynchro(): SynchroInterface
    {
        return $this->synchro;
    }
}