<?php

namespace UnicaenDbImport\Service;

use Interop\Container\ContainerInterface;
use UnicaenDbImport\CodeGenerator\PostgreSQL\CodeGenerator as PostgreSQLCodeGenerator;
use UnicaenDbImport\CodeGenerator\PostgreSQL\CodeGeneratorFactory as PostgreSQLCodeGeneratorFactory;
use Zend\ServiceManager\Factory\FactoryInterface;

class CodeGeneratorPluginManagerFactory implements FactoryInterface
{
    /**
     * @param ContainerInterface $container
     * @param string $requestedName
     * @param null|array $options
     * @return CodeGeneratorPluginManager
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        return new CodeGeneratorPluginManager($container, [
            'factories' => [
                PostgreSQLCodeGenerator::class => PostgreSQLCodeGeneratorFactory::class,
            ],
        ]);
    }
}