<?php

namespace UnicaenDbImport\Service;

use Interop\Container\ContainerInterface;
use UnicaenDbImport\Config\Config;
use UnicaenDbImport\QueryExecutor;

class DatabaseServiceFactory
{
    /**
     * @param ContainerInterface $container
     * @return DatabaseService
     */
    public function __invoke(ContainerInterface $container)
    {
        /** @var Config $config */
        $config = $container->get(Config::class);

        /** @var CodeGeneratorPluginManager $codeGeneratorPluginManager */
        $codeGeneratorPluginManager = $container->get(CodeGeneratorPluginManager::class);

        $codeGeneratorsConfig = $config->getCodeGeneratorsConfig();

        $databaseService = new DatabaseService(
            $codeGeneratorPluginManager,
            $codeGeneratorsConfig,
            new QueryExecutor()
        );

        return $databaseService;
    }
}