<?php

namespace UnicaenDbImport\Service;

use Interop\Container\ContainerInterface;

class FacadeServiceFactory
{
    /**
     * @param ContainerInterface $container
     * @return FacadeService
     */
    public function __invoke(ContainerInterface $container)
    {
        /** @var DatabaseService $databaseService */
        $databaseService = $container->get(DatabaseService::class);

        /** @var ApiService $apiService */
        $apiService = $container->get(ApiService::class);

        $service = new FacadeService($databaseService, $apiService);

        return $service;
    }
}